tff(dhol, logic, $$dhol == []).
thf(elem_type,type,
    elem: $tType ).
thf(nat_type,type,
    nat: $tType ).
thf(zero_type,type,
    zero: nat ).
thf(suc_type,type,
    suc: !> [X:nat]: nat ).
thf(plus_type,type,
    plus: !> [X:nat]: (!> [Y:nat]: nat) ).
thf(list_type,type,
    list: !> [X:nat]: $tType ).
thf(nil_type,type,
    nil: list(zero) ).
thf(cons_type,type,
    cons: !> [N:nat]: (!> [X:elem]: (!> [Y:list(N)]: list(suc(N)))) ).
thf(app_type,type,
    app: !> [N:nat]: (!> [M:nat]: (!> [X:list(N)]: (!> [Y:list(M)]: list(plus(N,M))))) ).
thf(rev_type,type,
    rev: !> [N:nat]: (!> [X:list(N)]: list(N)) ).

thf(peano1,axiom,
    ! [N:nat]: ((suc @ N) != zero) ).
thf(peano2,axiom,
    ! [N:nat,M:nat]: ((N != M) => ((suc @ N) != (suc @ M))) ).
thf(peano3,axiom,
    ! [P:(!> [X:nat]: $o)]: ((P @ zero) => ((! [M:nat]: ((P @ M) => (P @ (suc @ M)))) => (! [N:nat]: (P @ N)))) ).

thf(ax1,axiom,
    ! [N:nat]: ((plus @ zero @ N) = N) ).
thf(ax2,axiom,
    ! [N:nat,M:nat]: ((plus @ (suc @ N) @ M) = (suc @ (plus @ N @ M))) ).
thf(ax3,axiom,
    ! [N:nat,X:list(N)]: ((app @ zero @ N @ nil @ X) = X) ).
thf(ax4,axiom,
    ! [N:nat,M:nat,X:elem,Y:list(N),Z:list(M)]: ((app @ (suc @ N) @ M @ (cons @ N @ X @ Y) @ Z) = (cons @ (plus @ N @ M) @ X @ (app @ N @ M @ Y @ Z))) ).
thf(ax5,axiom,
    ((rev @ zero @ nil) = nil) ).
thf(ax6,axiom,
    ! [N:nat,X:elem,Y:list(N)]: ((rev @ (suc @ N) @ (cons @ N @ X @ Y)) = (app @ N @ (suc @ zero) @ (rev @ N @ Y) @ (cons @ zero @ X @ nil))) ).

thf(plus_com,axiom,(! [N:nat,M:nat]: ((plus @ N @ M) = (plus @ M @ N)))).
thf(plus1r,axiom,(! [N:nat]: ((suc @ N) = (plus @ N @ (suc @ zero))))).

thf(list_rev_invol_lem_indinst,axiom, ((! [M2:nat,L2:list(M2)] : ((rev @ (plus @ zero @ M2) @ (app @ zero @ M2 @ (rev @ zero @ nil) @ L2)) = (app @ M2 @ zero @ (rev @ M2 @ L2) @ nil))) => ((! [N:nat,X:elem,L:list(N)]: ((! [M2:nat,L2:list(M2)] : ((rev @ (plus @ N @ M2) @ (app @ N @ M2 @ (rev @ N @ L) @ L2)) = (app @ M2 @ N @ (rev @ M2 @ L2) @ L))) => (! [M2:nat,L2:list(M2)] : ((rev @ (plus @ (suc @ N) @ M2) @ (app @ (suc @ N) @ M2 @ (rev @ (suc @ N) @ (cons @ N @ X @ L)) @ L2)) = (app @ M2 @ (suc @ N) @ (rev @ M2 @ L2) @ (cons @ N @ X @ L)))))) => (! [N:nat,L:list(N)]: (! [M2:nat,L2:list(M2)] : ((rev @ (plus @ N @ M2) @ (app @ N @ M2 @ (rev @ N @ L) @ L2)) = (app @ M2 @ N @ (rev @ M2 @ L2) @ L))))))).

thf(list_rev_invol_lem_base,axiom, (! [M2:nat,L2:list(M2)] : ((rev @ (plus @ zero @ M2) @ (app @ zero @ M2 @ (rev @ zero @ nil) @ L2)) = (app @ M2 @ zero @ (rev @ M2 @ L2) @ nil)))).

thf(list_rev_invol_lem_indstep,axiom, (! [N:nat,X:elem,L:list(N)]: ((! [M2:nat,L2:list(M2)] : ((rev @ (plus @ N @ M2) @ (app @ N @ M2 @ (rev @ N @ L) @ L2)) = (app @ M2 @ N @ (rev @ M2 @ L2) @ L))) => (! [M2:nat,L2:list(M2)] : ((rev @ (plus @ (suc @ N) @ M2) @ (app @ (suc @ N) @ M2 @ (rev @ (suc @ N) @ (cons @ N @ X @ L)) @ L2)) = (app @ M2 @ (suc @ N) @ (rev @ M2 @ L2) @ (cons @ N @ X @ L))))))).

thf(list_rev_invol_lem,conjecture, (! [N:nat,L:list(N)]: (! [M2:nat,L2:list(M2)] : ((rev @ (plus @ N @ M2) @ (app @ N @ M2 @ (rev @ N @ L) @ L2)) = (app @ M2 @ N @ (rev @ M2 @ L2) @ L))))).

